package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.accumulatenetwork.sdk.protocol.TransactionBody;
import io.accumulatenetwork.sdk.protocol.TxID;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
import io.accumulatenetwork.sdk.support.serializers.GoBigIntDeserializer;
import io.accumulatenetwork.sdk.support.serializers.GoBigIntSerializer;
// UnionType: TransactionType
// UnionValue: SyntheticDepositTokens

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("SyntheticDepositTokens")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class SyntheticDepositTokens implements TransactionBody {
	public final TransactionType type = TransactionType.SYNTHETIC_DEPOSIT_TOKENS;
	private TxID cause;
	private Url source;
	private Url initiator;
	private long feeRefund;
	private Url token;
	private java.math.BigInteger amount;
	private boolean isIssuer;
	private boolean isRefund;

    //
	public TxID getCause() {
	    return cause;
	}
	public void setCause(final TxID value) {
	    this.cause = value;
	}

	public SyntheticDepositTokens cause(final TxID value) {
	    setCause(value);
	    return this;
	}
	public Url getSource() {
	    return source;
	}
	public void setSource(final Url value) {
	    this.source = value;
	}

	public SyntheticDepositTokens source(final Url value) {
	    setSource(value);
	    return this;
	}
	public SyntheticDepositTokens source(final String value) {
	    setSource(Url.toAccURL(value));
	    return this;
	}
	public Url getInitiator() {
	    return initiator;
	}
	public void setInitiator(final Url value) {
	    this.initiator = value;
	}

	public SyntheticDepositTokens initiator(final Url value) {
	    setInitiator(value);
	    return this;
	}
	public SyntheticDepositTokens initiator(final String value) {
	    setInitiator(Url.toAccURL(value));
	    return this;
	}
	public long getFeeRefund() {
	    return feeRefund;
	}
	public void setFeeRefund(final long value) {
	    this.feeRefund = value;
	}

	public SyntheticDepositTokens feeRefund(final long value) {
	    setFeeRefund(value);
	    return this;
	}
	public Url getToken() {
	    return token;
	}
	public void setToken(final Url value) {
	    this.token = value;
	}

	public SyntheticDepositTokens token(final Url value) {
	    setToken(value);
	    return this;
	}
	public SyntheticDepositTokens token(final String value) {
	    setToken(Url.toAccURL(value));
	    return this;
	}
	@JsonDeserialize(using = GoBigIntDeserializer.class)
	public java.math.BigInteger getAmount() {
	    return amount;
	}
	@JsonSerialize(using = GoBigIntSerializer.class)
	public void setAmount(final java.math.BigInteger value) {
	    this.amount = value;
	}

	public SyntheticDepositTokens amount(final java.math.BigInteger value) {
	    setAmount(value);
	    return this;
	}
	public boolean getIsIssuer() {
	    return isIssuer;
	}
	public void setIsIssuer(final boolean value) {
	    this.isIssuer = value;
	}

	public SyntheticDepositTokens isIssuer(final boolean value) {
	    setIsIssuer(value);
	    return this;
	}
	public boolean getIsRefund() {
	    return isRefund;
	}
	public void setIsRefund(final boolean value) {
	    this.isRefund = value;
	}

	public SyntheticDepositTokens isRefund(final boolean value) {
	    setIsRefund(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.cause == null)) {
            marshaller.writeTxid(2, this.cause);
        }
        if (!(this.source == null)) {
            marshaller.writeUrl(3, this.source);
        }
        if (!(this.initiator == null)) {
            marshaller.writeUrl(4, this.initiator);
        }
        if (!(this.feeRefund == 0)) {
            marshaller.writeUint(5, this.feeRefund);
        }
        if (!(this.token == null)) {
            marshaller.writeUrl(6, this.token);
        }
        if (!((this.amount).equals(java.math.BigInteger.ZERO))) {
            marshaller.writeBigInt(7, this.amount);
        }
        if (!(!this.isIssuer)) {
            marshaller.writeBool(8, this.isIssuer);
        }
        if (!(!this.isRefund)) {
            marshaller.writeBool(9, this.isRefund);
        }
        return marshaller.array();
    }
}
